<template>
  <div class="card shadow-sm">
    <Form @submit="submit" :validation-schema="schema">
      <div class="card-header">
        <h3 class="card-title" style="font-size: 20px; font-weight: bold">
          เลือกไฟล์
        </h3>
        <div class="card-toolbar">
          <button
            type="submit"
            class="btn btn-sm btn-light btn-primary me-2"
            style="font-size: 14px; font-weight: bold"
            @click="submit.prevent"
          >
            Import
          </button>
          <button
            type="button"
            class="btn btn-sm btn-light btn-danger"
            style="font-size: 14px; font-weight: bold"
            @click="cancel"
          >
            Cancel
          </button>
        </div>
      </div>
      <!-- form -->
      <div class="card-body">
        <!-- -->
        <div class="row text-sm-start text-md-end mb-10">
          <button
            type="submit"
            class="btn btn-sm btn-light btn-primary col-sm-2"
            style="font-size: 14px; font-weight: bold"
          >
            Choose File
          </button>
          <div class="col-sm-6 align-content-end">
            <Field
              v-model="form.inputFile"
              type="text"
              class="form-control form-control-solid"
              placeholder="No file Chosen"
              name="inputFile"
              id="inputFile"
              disabled="disabled"
            />
          </div>
        </div>
        <div class="row text-sm-start text-md-end">
          <label for="detailFile" class="form-label col-sm-2">ข้อมูล</label>
          <div class="col-sm-9">
            <textarea
              class="form-control"
              id="floatingTextarea2"
              style="height: 100px"
            ></textarea>
          </div>
        </div>
      </div>
    </Form>
  </div>
</template>

<script>
import Swal from "sweetalert2/dist/sweetalert2.js";
import { ErrorMessage, Field, Form } from "vee-validate";
import * as Yup from "yup";

export default {
  components: {
    Field,
    Form,
    ErrorMessage,
  },
  data() {
    const schema = Yup.object({
      // retailPrice: Yup.string().required("กรุณากรอก !"),
      // password: Yup.string().required().min(8),
    });
    return {
      schema,
      searchProduct: "",
      form: {
        inputFile: "",
        detailFile: "",
      },
    };
  },
  methods: {
    async submit() {
      await this.validateForm();
      await this.checkFormIsEmpty();
      if (this.isValid) {
        this.$router.go(-1);
      }
    },

    checkFormIsEmpty() {
      !this.form.installment
        ? (this.isValid = false)
        : !this.form.startDate
        ? (this.isValid = false)
        : !this.form.endDate
        ? (this.isValid = false)
        : (this.isValid = true);
    },

    validateForm() {
      let forms = document.querySelectorAll(".needs-validation");
      Array.prototype.slice.call(forms).forEach(function (form) {
        form.addEventListener(
          "submit",
          function (event) {
            if (!form.checkValidity()) {
              event.preventDefault();
              event.stopPropagation();
            }

            form.classList.add("was-validated");
          },
          false
        );
      });
    },

    cancel() {
      this.$router.go(-1);
    },
  },
};
</script>
